/* Create a picture with some geometrical figures.

   For the article
   "Singularity Detection in Images Using Dual Local Autocovariance"
   by  Wojciech Czaja and Mladen Victor Wickerhauser.

   Programmers: W.K.Czaja and M.V.Wickerhauser <victor@math.wustl.edu>
   Date: 22 July 2001
*/

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

int
main()
{
  int width, height;
  int i, j;
  unsigned char *dat;

  width = 256;	
  height = 256;	

  /* Allocate enough storage to hold the input: */
  dat = (unsigned char *)malloc( width*height);  assert(dat);

  /* Main diagonal is an edge */
  for ( i=0; i<height; i++ ) 
    for ( j=0; j<width; j++ )
      if ( i<j )
        dat[i*width+j] = 150;
      else
        dat[i*width+j] = 220;  

  /* Disk of radius 40: */
  for ( i=0; i<height; i++ ) 
    for ( j=0; j<width; j++ )
      if ( (i-110)*(i-110)+(j-60)*(j-60)< 1600 )
        dat[i*width+j] -= 110;

  /* Square, 99x99 pixels: */
  for ( i=0; i<height; i++ ) 
    for ( j=0; j<width; j++ )
      if ( ( i>100 ) && ( i<200 ) && ( j>125 ) && ( j<225 ) )
        dat[i*width+j] -= 60;

  printf("P5\n%d %d\n255\n", width, height); /* PGM header */
  fwrite(dat, 1, width*height, stdout); /* PGM data */
  
  free(dat); 
  exit(0);

}
